<template>
  <div>
    <b-row>
      <b-colxx xxs="12">
        <div class="top-right-button-container">
          <b-button
            v-if="currentUser && currentUser.role === true"
            v-b-modal.modalnew
            variant="success"
            size="lg"
            class="top-right-button"
            >Add</b-button
          >
          <b-button
            v-if="currentUser && currentUser.role === true"
            v-b-modal.modalbasic
            variant="danger"
            size="lg"
            class="top-right-button"
            :disabled="bootstrapTable.selected.length <= 0"
            >Delete</b-button
          >
          <b-button
            v-if="currentUser && currentUser.role === true"
            v-b-modal.modalright
            variant="primary"
            size="lg"
            class="top-right-button"
            :disabled="bootstrapTable.selected.length != 1"
            >Edit</b-button
          >
          <b-modal id="modalbasic" ref="modalbasic" :title="'Suppression'">
            Voulez-vous vraiment supprimer le(s)
            {{ bootstrapTable.selected.length }} user(s) séléctionnés ?
            <template slot="modal-footer">
              <b-button variant="primary" @click="deleteCryptos()" class="mr-1"
                >Confirm</b-button
              >
              <b-button variant="secondary" @click="hideModal('modalbasic')"
                >Cancel</b-button
              >
            </template>
          </b-modal>
          <b-modal
            id="modalright"
            ref="modalright"
            :title="'Edit crypto'"
            class="modal-right"
          >
            <b-form v-if="bootstrapTable.selected[0]">
              <b-form-group :label="'Name'">
                <b-form-input v-model="bootstrapTable.selected[0].name" />
              </b-form-group>
              <b-form-group :label="'Id Api'">
                <b-form-select
                  v-model="bootstrapTable.selected[0].id_api"
                  :options="optionsIdApi"
                />
              </b-form-group>
              <b-form-group :label="'Current price usd'">
                <b-form-input
                  type="number"
                  v-model="bootstrapTable.selected[0].current_price_usd"
                />
              </b-form-group>
              <b-form-group :label="'Current price eur'">
                <b-form-input
                  type="number"
                  v-model="bootstrapTable.selected[0].current_price_eur"
                />
              </b-form-group>
              <b-form-group :label="'State: '">
                <b-form-radio-group
                  stacked
                  class="pt-2"
                  v-model="bootstrapTable.selected[0].is_active"
                  :options="
                    states.map((c) => {
                      return { text: c.label, value: c.value }
                    })
                  "
                />
              </b-form-group>
            </b-form>

            <template slot="modal-footer">
              <b-button
                variant="outline-secondary"
                @click="hideModal('modalright')"
                >cancel</b-button
              >
              <b-button variant="primary" @click="updateCrypto()" class="mr-1"
                >validate</b-button
              >
            </template>
          </b-modal>

          <b-modal
            id="modalnew"
            ref="modalnew"
            :title="'Add a crypto'"
            class="modal-right"
          >
            <b-form>
              <b-form-group :label="'Name'">
                <b-form-input v-model="newCrypto.name" />
              </b-form-group>
              <b-form-group :label="'Id Api'">
                <b-form-select
                  v-model="newCrypto.id_api"
                  :options="optionsIdApi"
                />
              </b-form-group>
              <b-form-group :label="'State: '">
                <b-form-radio-group
                  stacked
                  class="pt-2"
                  v-model="newCrypto.is_active"
                  :options="
                    states.map((c) => {
                      return { text: c.label, value: c.value }
                    })
                  "
                />
              </b-form-group>
            </b-form>

            <template slot="modal-footer">
              <b-button
                variant="outline-secondary"
                @click="hideModal('modalright')"
                >cancel</b-button
              >
              <b-button variant="primary" @click="addCrypto()" class="mr-1"
                >Add</b-button
              >
            </template>
          </b-modal>
        </div>

        <h1>All Cryptos</h1>
        <div class="separator mb-5"></div>
      </b-colxx>
    </b-row>
    <b-row>
      <b-colxx xxs="12">
        <template>
          <div class="text-center">
            <div class="row d-flex justify-content-center">
              <div
                v-if="!currentUser || currentUser.role === false"
                class="row d-flex justify-content-center"
              >
                <b-card
                  v-for="(crypto, index) in pageOfItems"
                  :key="index"
                  ref="custom-table"
                  class="vuetable col-md-5 text-center m-1"
                  sort-by="id"
                  sort-desc.sync="false"
                  :current-page="currentPage"
                  :per-page="perPage"
                  :items="items"
                  :pagination="true"
                >
                  <img
                    :src="crypto.url_image"
                    style="
                      max-width: 50px;
                      margin-bottom: 30px;
                      margin-right: 15px;
                    "
                  />
                  <h1 v-if="currentUser" class="display-4">
                    <a :href="'history?id=' + crypto.id_api +  '&pid=' + crypto.id">{{
                      crypto.name
                    }}</a>
                  </h1>
                  <h1 v-if="!currentUser" class="display-4">
                    {{ crypto.name }}
                  </h1>
                  <b-badge
                    variant="success"
                    class="position-absolute ml-1"
                    v-if="crypto.evolution_price > 0"
                    >&#9650;</b-badge
                  >
                  <b-badge
                    variant="danger"
                    class="position-absolute ml-1"
                    v-else-if="crypto.evolution_price < 0"
                    >&#9660;</b-badge
                  >
                  <b-badge
                    variant="primary"
                    class="position-absolute ml-1"
                    v-else
                    >=</b-badge
                  >

                  <div v-if="currentUser && user.currency == 'USD'">
                    <h1>
                      Curent Price :
                      <span class="font-weight-bold">{{
                        crypto.current_price_usd
                      }}</span>
                      $
                    </h1>
                    <br />
                    <div>
                      <h1 class="m-0 p-0">Last 24h</h1>
                      <div class="row">
                        <h2 class="col">
                          Highest Price<br /><span
                            class="font-weight-bold text-success"
                            >{{ crypto.highest_price_usd }}</span
                          >
                          $
                        </h2>
                        <h2 class="col">
                          Lowest Price<span class="font-weight-bold text-danger"
                            ><br />{{ crypto.lowest_price_usd }}</span
                          >
                          $
                        </h2>
                      </div>
                      <b-button
                        v-if="currentUser && crypto.subscribed == 'false'"
                        variant="success"
                        @click="subscribe(crypto.id)"
                        >Subscribe</b-button
                      >
                      <b-button
                        v-if="currentUser && crypto.subscribed == 'true'"
                        variant="danger"
                        @click="unsubscribe(crypto.id)"
                        >Unsubscribe</b-button
                      >
                    </div>
                  </div>
                  <div v-else>
                    <h1>
                      Curent Price :
                      <span class="font-weight-bold">{{
                        crypto.current_price_eur
                      }}</span>
                      €
                    </h1>
                    <br />
                    <div>
                      <h1 class="m-0 p-0">Last 24h</h1>
                      <div class="row">
                        <h2 class="col">
                          Highest Price<br /><span
                            class="font-weight-bold text-success"
                            >{{ crypto.highest_price_eur }}</span
                          >
                          €
                        </h2>
                        <h2 class="col">
                          Lowest Price<span class="font-weight-bold text-danger"
                            ><br />{{ crypto.lowest_price_eur }}</span
                          >
                          €
                        </h2>
                      </div>
                      <b-button
                        v-if="currentUser && crypto.subscribed == 'false'"
                        variant="success"
                        @click="subscribe(crypto.id)"
                        >Subscribe</b-button
                      >
                      <b-button
                        v-if="currentUser && crypto.subscribed == 'true'"
                        variant="danger"
                        @click="unsubscribe(crypto.id)"
                        >Unsubscribe</b-button
                      >
                    </div>
                  </div>
                </b-card>
              </div>
            </div>
            <div class="w-100 pb-2 pt-3">
              <jw-pagination
                :items="items"
                @changePage="onChangePage"
                :pageSize="4"
                v-if="!currentUser || currentUser.role === false"
              ></jw-pagination>
            </div>
          </div>
        </template>

        <b-table
          ref="custom-table"
          class="vuetable"
          sort-by="title"
          sort-desc.sync="false"
          @row-selected="rowSelected"
          selectable
          :select-mode="bootstrapTable.selectMode"
          :current-page="currentPage"
          selectedVariant="primary"
          :fields="bootstrapTable.fields"
          :items="items"
          v-if="currentUser && currentUser.role === true"
        >
          <template slot="status" slot-scope="data">
            <b-badge class="mb-1" :variant="data.item.statusColor">{{
              data.value
            }}</b-badge>
          </template>
        </b-table>
        <b-pagination
          size="sm"
          align="center"
          :total-rows="items.length"
          :per-page="perPage"
          v-model="currentPage"
          v-if="currentUser && currentUser.role === true"
        >
          <template v-slot:next-text>
            <i class="simple-icon-arrow-right" />
          </template>
          <template v-slot:prev-text>
            <i class="simple-icon-arrow-left" />
          </template>
          <template v-slot:first-text>
            <i class="simple-icon-control-start" />
          </template>
          <template v-slot:last-text>
            <i class="simple-icon-control-end" />
          </template>
        </b-pagination>

        <!-- <b-alert v-if="bootstrapTable.selected.length>0" show variant="primary">Selected Items :<br/><pre>{{ bootstrapTable.selected }}</pre></b-alert> -->
      </b-colxx>
    </b-row>
  </div>
</template>
<script>
import Vue from 'vue'
import { mapGetters } from 'vuex'
import { Notyf } from 'notyf'
import JwPagination from 'jw-vue-pagination'
Vue.component('jw-pagination', JwPagination)
import 'notyf/notyf.min.css'
export default {
  components: {},
  data() {
    return {
      user: {},
      pageOfItems: [],
      items: [{}],
      currentPage: 1,
      perPage: 6,
      totalRows: 0,
      subscribed: true,
      bootstrapTable: {
        selected: [],
        selectMode: 'multi',
        fields: [
          {
            key: 'name',
            label: 'Name',
            sortable: true,
            sortDirection: 'desc',
            tdClass: 'list-item-heading',
          },
          {
            key: 'current_price_usd',
            label: 'Current price usd',
            sortable: true,
            tdClass: 'text-muted',
          },
          {
            key: 'current_price_eur',
            label: 'Current price eur',
            sortable: true,
            tdClass: 'text-muted',
          },
          {
            key: 'is_active',
            label: 'Is Active',
            sortable: true,
            tdClass: 'text-muted',
          },
        ],
      },
      selectedUser: {},
      states: [
        { label: 'Activate', value: true },
        { label: 'Desactivate', value: false },
      ],
      newCrypto: {
        name: '',
        id_api: '',
        current_price_usd: '',
        current_price_eur: '',
        is_active: true,
      },
      optionsIdApi: [],
    }
  },
  methods: {
    onPaginationData(paginationData) {
      this.$refs.pagination.setPaginationData(paginationData)
    },
    history(id) {
      // console.log('id', id)
    },
    subscribe(id) {
      // console.log("id", id)
      Vue.prototype.$http
        .post(
          `http://localhost:3000/api/myCryptos/${this.currentUser.id}/${id}`
        )
        .then((data) => {
          this.dataProvider()
          const notyf = new Notyf()
          notyf.success('Successfuly subscribed !')
        })
    },
    unsubscribe(id) {
      // console.log("id", id)
      Vue.prototype.$http
        .delete(
          `http://localhost:3000/api/myCryptos/${this.currentUser.id}/${id}`
        )
        .then((data) => {
          this.dataProvider()
          const notyf = new Notyf()
          notyf.success('Successfuly unsubscribed !')
        })
    },
    onChangePage(pageOfItems) {
      // update page of items
      this.pageOfItems = pageOfItems
    },
    rowSelected(items) {
      this.bootstrapTable.selected = items
      this.selectedUser = items[0]
    },
    async dataProvider(ctx) {
      return await Vue.prototype.$http
        .get('http://localhost:3000/api/cryptos')
        .then((result) => result.data)
        .then((data) => {
          this.currentPage = data.current_page
          this.perPage = data.per_page
          this.totalRows = data.total
          this.items = data
          // console.log('items', this.items)
          // this.items = this.items.filter(i => {
          //   if (this.currentUser.role === false) {
          //     if (i.is_active === true) {
          //       return i
          //     }
          //   } else {
          //     return i
          //   }
          // })
          // console.log("apres filter", this.items)
          return this.items
        })
        .catch((_error) => {
          return []
        })
    },
    apiParamsConverter(params) {
      let apiParams = {}
      if (params.perPage !== 0) {
        apiParams.per_page = params.perPage
      }
      if (params.currentPage >= 1) {
        apiParams.page = params.currentPage
      }
      if (params.sortBy.length > 0) {
        apiParams.sort = `${params.sortBy}|${params.sortDesc ? 'desc' : 'asc'}`
      }
      if (params.filter.length > 0) {
        // Optional
      }
      return apiParams
    },
    hideModal(refname) {
      this.$refs[refname].hide()
      this.dataProvider()
    },
    addNotification(type, title, message) {
      this.$notify(type, title, message, { duration: 3000, permanent: false })
    },
    updateCrypto() {
      this.hideModal('modalright')
      Vue.prototype.$http
        .patch(
          'http://localhost:3000/api/cryptos/' +
            this.bootstrapTable.selected[0].id,
          this.bootstrapTable.selected[0]
        )
        .then((res) => {
          this.dataProvider()
        })
        .catch((err) => {
          // console.log(err)
        })
    },
    deleteCryptos() {
      this.hideModal('modalbasic')
      this.bootstrapTable.selected.forEach((c) => {
        Vue.prototype.$http
          .delete('http://localhost:3000/api/cryptos/' + c.id)
          .then((res) => {
            const index = this.items.indexOf(c)
            if (index > -1) {
              this.items.splice(index, 1)
            }
            this.addNotification('success', 'suppression', 'crypto deleted')
            this.dataProvider()
          })
      })

    },
    addCrypto() {
      // eslint-disable-next-line
       this.hideModal('modalnew')
      // console.log(this.newCrypto);
      const cryptoNew = {
        current_price_eur: 0,
        current_price_usd: 0,
        id_api: this.newCrypto.id_api,
        is_active: this.newCrypto.is_active,
        name: this.newCrypto.name
      }

      Vue.prototype.$http
        .post('http://localhost:3000/api/cryptos/', cryptoNew)
        .then((res) => {
          // console.log(res)
          this.dataProvider()
        })
        .catch((err) => {
          console.log(err)
        })
    },
  },
  computed: {
    ...mapGetters({
      currentUser: 'currentUser',
    }),
  },
  mounted() {
    Vue.prototype.$http
      .get(`http://localhost:3000/api/cryptos/full_list`)
      .then((result) => {
        this.optionsIdApi = result.data
      })

    this.dataProvider()
    if (this.currentUser) {
      Vue.prototype.$http
        .get(`http://localhost:3000/api/users/${this.currentUser.id}`)
        .then((result) => result.data)
        .then((data) => {
          this.user = data
          // console.log('user', this.user)
          // this.items = this.items.filter(i => {
          //   if (this.currentUser.role === false) {
          //     if (i.is_active === true) {
          //       return i
          //     }
          //   } else {
          //     return i
          //   }
          // })
          // console.log("apres filter", this.items)
          return this.user
        })
        .catch((_error) => {
          return []
        })
    }
  },
}
</script>

<style scoped>
  ul.pagination {
    display: flex !important;
    justify-content: center !important;
  }
</style>
